package core

import (
	"fmt"

	"git.akyoto.dev/cli/q/src/build/asm"
	"git.akyoto.dev/cli/q/src/build/ast"
)

// CompileIf compiles a branch instruction.
func (f *Function) CompileIf(branch *ast.If) error {
	startLabel := fmt.Sprintf("%s_if_start_%d", f.Name, f.count.branch)
	endLabel := fmt.Sprintf("%s_if_end_%d", f.Name, f.count.branch)
	err := f.CompileCondition(branch.Condition, startLabel, endLabel)

	if err != nil {
		return err
	}

	f.assembler.Label(asm.LABEL, startLabel)
	defer f.assembler.Label(asm.LABEL, endLabel)
	f.count.branch++
	return f.CompileAST(branch.Body)
}
